#include "stdafx.h"

int leelin(FILE *fi, char *linea);
void transforma(char *dat,double d,int l);

BOOL CalcStringEllipsis(HDC hdc, LPTSTR lpszString, int cchMax, UINT uColWidth)
{
    const TCHAR szEllipsis[] = TEXT("...");
    SIZE   sizeString;
    SIZE   sizeEllipsis;
    int    cbString;
    LPTSTR lpszTemp;
    BOOL   fSuccess = FALSE;
   
        /* ajusta el ancho de la columna para tener en cuenta los bordes */

    uColWidth -= 4;

    __try
    {
        /* prepara cadena de trabajo */
        
        lpszTemp = (LPTSTR) HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, cchMax);
        if (!lpszTemp)
        {
            __leave;
        }
        lstrcpy(lpszTemp, lpszString);

        /* obtiene la longitud del texto en pixels */

        cbString = lstrlen(lpszTemp);
        if (!(GetTextExtentPoint32)(hdc, lpszTemp, cbString, &sizeString))
        {
            __leave;
        }

        /* si el ancho de la cadena es mayor que el ancho de la columna
		   hay que poner los puntos */

        if ((ULONG)sizeString.cx > uColWidth)
        {
            if (!(GetTextExtentPoint32)(hdc, szEllipsis, lstrlen(szEllipsis),
                                       &sizeEllipsis))
            {
                __leave;
            }

            while (cbString > 0)
            {
                lpszTemp[--cbString] = 0;
                if (!(GetTextExtentPoint32)(hdc, lpszTemp, cbString, &sizeString))
                {
                    __leave;
                }

                if ((ULONG)(sizeString.cx + sizeEllipsis.cx) <= uColWidth)
                {
                    if (cchMax >= (cbString + lstrlen(szEllipsis)))
                    {
                        lstrcat(lpszTemp, szEllipsis);
                        lstrcpy(lpszString, lpszTemp);
                        fSuccess = TRUE;
                        __leave;
                    }
                }
            }
        }
        else
        {
            fSuccess = TRUE;
        }
    }
    __finally
    {
        HeapFree(GetProcessHeap(), 0, (LPVOID)lpszTemp);
        return (fSuccess);
    }
}

void DrawItemColumn(HDC hdc, LPCTSTR lpsz, LPRECT prcClip)
{
    TCHAR szString[256];

    /* mira a ver si el texto cabe en el ancho de 
	   la columna si no es asi tiene que poner "..." */

    lstrcpy(szString, lpsz);
    CalcStringEllipsis(hdc, szString, 256, prcClip->right - prcClip->left);

    /* escribe el texto */

    ExtTextOut(hdc, prcClip->left + 2, prcClip->top + 1, ETO_CLIPPED | ETO_OPAQUE,
               prcClip, szString, lstrlen(szString), NULL);

}

void DrawListViewItem(LPDRAWITEMSTRUCT lpDrawItem,CListCtrl *lista)
{
    HIMAGELIST himl;
    LV_ITEM lvi;
    int cxImage = 0, cyImage = 0;
    UINT uFirstColWidth;
    RECT rcClip;
    int iColumn = 1;
	UINT uiFlags = ILD_TRANSPARENT;
	register int t;

    /* obtiene la imagen a dibujar */

    lvi.mask = LVIF_IMAGE | LVIF_STATE;
    lvi.iItem = lpDrawItem->itemID;
    lvi.iSubItem = 0;
    ListView_GetItem(lpDrawItem->hwndItem, &lvi);

    /* mira a ver si la linea esta seleccionada */

    if (lpDrawItem->itemState & ODS_SELECTED)
    {
        /* prepara los colores de background y foreground */

        SetTextColor(lpDrawItem->hDC, GetSysColor(COLOR_HIGHLIGHTTEXT));
        SetBkColor(lpDrawItem->hDC, GetSysColor(COLOR_HIGHLIGHT));

		uiFlags |= ILD_BLEND50;
    }
    else
    {
        /* asigna a los colores de background y foreground los de Windows */
        
        SetTextColor(lpDrawItem->hDC, GetSysColor(COLOR_WINDOWTEXT));
        SetBkColor(lpDrawItem->hDC, GetSysColor(COLOR_WINDOW));
    }


        /* obtiene la lista de imagenes y dibuja la imagen */

    himl = ListView_GetImageList(lpDrawItem->hwndItem, LVSIL_SMALL);
    if (himl)
    {
        ImageList_Draw(himl, lvi.iImage, lpDrawItem->hDC,
                       lpDrawItem->rcItem.left, lpDrawItem->rcItem.top,
                       uiFlags);

        ImageList_GetIconSize(himl, &cxImage, &cyImage);
    }

    /* calcula el ancho de la primera columna detras 
	   de la imagen, si no hay imagen cxImage es cero */

    uFirstColWidth = lista->GetColumnWidth(0) - cxImage;

    rcClip.left = lpDrawItem->rcItem.left + cxImage;
    rcClip.right = lpDrawItem->rcItem.left + lista->GetColumnWidth(0);
    rcClip.top = lpDrawItem->rcItem.top;
    rcClip.bottom = lpDrawItem->rcItem.bottom;

    DrawItemColumn(lpDrawItem->hDC, (LPCTSTR) lista->GetItemText(lpDrawItem->itemID,0),
                   &rcClip);

	for (t=1;t<5;t++) {
       rcClip.left = rcClip.right;
       rcClip.right = rcClip.left + lista->GetColumnWidth(t);
       DrawItemColumn(lpDrawItem->hDC,(LPCTSTR) lista->GetItemText(lpDrawItem->itemID,t),
                      &rcClip);
	}   

    /* deshace el cambio de color */
	
    if (lpDrawItem->itemState & ODS_SELECTED)
    {
        SetTextColor(lpDrawItem->hDC, GetSysColor(COLOR_WINDOWTEXT));
        SetBkColor(lpDrawItem->hDC, GetSysColor(COLOR_WINDOW));
    }

    /* si el item esta seleccionado dibuja el recuadro del cursor */

    if (lpDrawItem->itemState & ODS_FOCUS)
    {
        rcClip = lpDrawItem->rcItem;
        rcClip.left += cxImage;

        DrawFocusRect(lpDrawItem->hDC, &rcClip);
    }

    return;
}

void lista_informes::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
      DrawListViewItem(lpDrawItemStruct,this);
}

BEGIN_MESSAGE_MAP(listado1,CButton)
//{{AFX_MSG_MAP(listado1)
ON_WM_KEYDOWN()
ON_WM_SIZE()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()
      
void listado1::create(CWnd *par, CRect *in_rect)
{
      CRect rect;
      register int t,u,r;
	  int n,i,j,lx,ly,l;
	  char fichero[25],linea[251],senten[1024],val_m[1500][61],tex_er[71],texto[61];
	  int tipo[5],n_max,n_reg,resul,n_vari;
	  FILE *fi;
	  double f;
	  LV_ITEM *item;
	  LV_COLUMN *columna;
	  	  
      parent=par;
      listado *li=(listado *) parent;

	  mask = new CBitmap;
	  peq = new CBitmap;
	  imagen = new CImageList;
	  lista = new lista_informes;

	  rect=*in_rect;
	  
      Create("",WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_GROUP |  BS_GROUPBOX,rect,par,NULL);

	  peq->LoadBitmap("IDB_SMALL");
	  mask->LoadBitmap("IDB_MASK");

	  imagen->Create(32,16,ILC_MASK,3,3);
	  imagen->Add(peq,mask);
	  	  
	  j=1;
	  n=76*4;
	  i=baseY/2;
	  lx=((n*baseX)/4)+2;
	  ly=(150*baseY)/8;

      lista->Create(WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_BORDER | LVS_NOSORTHEADER | LVS_REPORT | LVS_SINGLESEL | LVS_SHAREIMAGELISTS | LVS_SHOWSELALWAYS | LVS_OWNERDRAWFIXED,CRect(j,i,lx,ly),this,NULL);

	  lista->SetImageList(imagen,LVSIL_SMALL);

	  columna=(LV_COLUMN *) malloc(sizeof(LV_COLUMN));

      columna->mask=LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
      
      columna->fmt=LVCFMT_LEFT;

	  for (t=0;t<5;t++) {
		 if (!t) {
            if (lenguaje=='E')
	           columna->pszText="Informe";
            else
               columna->pszText="Report";
	        columna->cx=((15*4)*baseX)/4;
		 }
		 if (t==1) {
            columna->pszText="Rv";
	        columna->cx=((4*4)*baseX)/4;
		 }
		 if (t==2) {
			columna->pszText="O";
	        columna->cx=((3*4)*baseX)/4;
		 }
		 if (t==3) {
            if (lenguaje=='E')
               columna->pszText="Descripcin";
            else
               columna->pszText="Description";
	        columna->cx=((40*4)*baseX)/4;
		 }
		 if (t==4) {
            if (lenguaje=='E')
               columna->pszText="Fecha";
            else
               columna->pszText="Date";
	        columna->cx=((10*4)*baseX)/4;
		 }
         columna->iSubItem=t;
		 lista->InsertColumn(t,columna);
	  }
	  
	  free(columna);
	  
		              /* obtiene la lista a insertar */

      strcpy(fichero,li->nombre);
      strcat(fichero,".lst");

      if ((fi=fopen(fichero,"r"))!=NULL) {
         do {
            l=leelin(fi,linea);
	        if (l==EOF) break;
	        rtrim(linea);
			break;
		 } while(1);
		 fclose(fi);
	  }

	  strcpy(senten,"select listado,revision,oficial,denominacion,to_char(fecha,'RR-MM-DD') from ");
	  strcat(senten,linea);
	  strcat(senten," a where revision=(select max(revision) from ");
	  strcat(senten,linea);
	  strcat(senten," b where b.listado=a.listado) order by 1");
	  	 
	  n_vari=5;
	  tipo[0]=1;
	  tipo[1]=4;
	  tipo[2]=1;
	  tipo[3]=1;
	  tipo[4]=1;
      n_max=300;
	  
	  resul=sq3_or(li->contex_gen,senten,tipo,n_vari,n_max,&n_reg,val_m,tex_er);

	  if (n_reg) lista->SetItemCount(n_reg);

	  item=(LV_ITEM *) malloc(sizeof(LV_ITEM));

	  item->mask=LVIF_TEXT | LVIF_PARAM;

	  unsigned char a='\0';
      
	  item->lParam=MAKELPARAM(MAKEWORD(a,a),MAKEWORD(a,a));
	  	  	  
      for (t=0,u=0;t<n_reg*5;t+=5,u++) {
	     f=num(val_m[t+1]);
         transforma(texto,f,2);
		 rtrim(texto);
	     ltrim(texto);
		 if (!strcmp(texto,"0")) texto[0]='\0';
		 strcpy(val_m[t+1],texto);
		 item->iItem=u;
		 item->iSubItem=0;
         item->pszText=val_m[t];
		 lista->InsertItem(item);
		 for (r=1;r<5;r++) lista->SetItemText(u,r,val_m[t+r]);
	  }

	  lista->SetItemState(0,LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);

	  for (t=1;t<n_reg;t++) lista->SetItemState(t,NULL,LVIS_FOCUSED | LVIS_SELECTED); 
      
      free(item);

	  for (t=0;t<n_reg;t++) asignar_imagen(t);

	  lista->SetFont(fonm,TRUE);
	  lista->SetFocus();
}	  

void listado1::asignar_imagen(int numero)
{
      LV_ITEM *item;
	  char fichero[256],file[256],informe[16],oficial[2],descripcion[41],fecha[11],revi[3];
	  int revision,i;

	  listado *li=(listado *) parent;

	      /* obtiene el nombre del fichero */

      revision=obtener_registro(numero,informe,oficial,descripcion,fecha);	  
	  strcpy(fichero,li->dir);
      strcat(fichero,"\\");
	  strcat(fichero,informe);
	  strcat(fichero,"_");
	  sprintf(revi,"%02d",revision);
	  strcat(fichero,revi);
	  strcpy(file,fichero);
	  strcat(fichero,".lis");
	  strcat(file,".xis");

          /* asigna los datos a modificar para el item */

	  item=(LV_ITEM *) malloc(sizeof(LV_ITEM));
	  item->mask=LVIF_IMAGE;
	  item->iItem=numero;        
      item->iSubItem=0;

	  if ((i=_open(fichero,_O_RDONLY))==-1)	
		 item->iImage=0;
	  else {
         _close(i);
		 if ((i=_open(file,_O_RDONLY))==-1)
		    item->iImage=1;
		 else {
		    _close(i);
            item->iImage=2;
		 } 
	  }

	  lista->SetItem(item);
	  free(item);
}

void listado1::actualizar_registro(char *informe)
{
      int n_vari,tipo[4],resul,l;
	  char senten[1024],valor[4][61],tex_er[71],linea[101],fichero[256],texto[3];
	  double f;
	  FILE *fi;
	  LV_FINDINFO info;
	 
	  listado *li=(listado *) parent;

	  info.flags=LVFI_STRING;
	  info.psz=informe;
	  
	  int numero=lista->FindItem(&info);	  

	  asignar_imagen(numero);

      strcpy(fichero,li->nombre);
      strcat(fichero,".lst");

      if ((fi=fopen(fichero,"r"))!=NULL) {
         do {
            l=leelin(fi,linea);
	        if (l==EOF) break;
	        rtrim(linea);
			break;
		 } while(1);
		 fclose(fi);
	  }

	  strcpy(senten,"select revision,oficial,denominacion,to_char(fecha,'RR-MM-DD') from ");
	  strcat(senten,linea);
	  strcat(senten," a where revision=(select max(revision) from ");
	  strcat(senten,linea);
	  strcat(senten," b where b.listado=a.listado) and a.listado='");
	  strcat(senten,informe);
	  strcat(senten,"'");
	  	 
	  n_vari=4;
	  tipo[0]=4;
      tipo[1]=1;
      tipo[2]=1;
	  tipo[3]=1;
	  
      resul=sq1_or(li->contex_gen,senten,valor,tipo,n_vari,tex_er); 

	  f=num(valor[0]);
      transforma(texto,f,2);
	  rtrim(texto);
	  ltrim(texto);
	  if (!strcmp(texto,"0")) texto[0]='\0';
	
      lista->SetItemText(numero,1,texto);
	  lista->SetItemText(numero,2,valor[1]);
      lista->SetItemText(numero,3,valor[2]);
	  lista->SetItemText(numero,4,valor[3]);
	  this->asignar_imagen(numero);
}
	  
int listado1::obtener_registro(int numero, char *informe, char *oficial, char *descripcion, char *fecha)	  
{
	  char revision[3];

      informe[0]='\0';
      revision[0]='\0';
      oficial[0]='\0';
      descripcion[0]='\0';
      fecha[0]='\0';

	  lista->GetItemText(numero,0,informe,16);
	  lista->GetItemText(numero,1,revision,3);
	  lista->GetItemText(numero,2,oficial,2);
	  lista->GetItemText(numero,3,descripcion,41);
	  lista->GetItemText(numero,4,fecha,11);
	           
	  return(atoi(revision));
}

void listado1::OnSize(UINT nType,int cx,int cy)
{
	  CButton::OnSize(nType,cx,cy);
	  if (lista->m_hWnd)
         lista->MoveWindow(1,baseY/2,cx-2,cy-(baseY/2),TRUE);
}

int listado1::obtener_seleccionado()
{
      register int t;

      for (t=0;t<lista->GetItemCount();t++) {
         if (lista->GetItemState(t,LVIS_SELECTED) == LVIS_SELECTED ||
		    lista->GetItemState(t,LVIS_FOCUSED) == LVIS_FOCUSED) return(t);
	  } 
	  return(-1);
}

char listado1::get_marca_edit(int numero)
{
	  return((char) LOBYTE(LOWORD(lista->GetItemData(numero))));
}

char listado1::get_marca_rejilla(int numero)
{
      return((char) HIBYTE(LOWORD(lista->GetItemData(numero))));
}

char listado1::get_marca_ver(int numero) 
{
	  return((char) LOBYTE(HIWORD(lista->GetItemData(numero))));
}

char listado1::get_marca_exec(int numero)
{
	  return((char) HIBYTE(HIWORD(lista->GetItemData(numero))));
}

void listado1::put_marca_edit(char *informe,char marca)
{
	  unsigned char d,i,v,e;

	  LV_FINDINFO info;

	  info.flags=LVFI_STRING;
	  info.psz=informe;
	  
	  int numero=lista->FindItem(&info);

	  d=LOBYTE(LOWORD(lista->GetItemData(numero)));
      i=HIBYTE(LOWORD(lista->GetItemData(numero)));
	  v=LOBYTE(HIWORD(lista->GetItemData(numero)));
	  e=HIBYTE(HIWORD(lista->GetItemData(numero)));

	  lista->SetItemData(numero,MAKELPARAM(MAKEWORD((unsigned char) marca,i),MAKEWORD(v,e)));
}

void listado1::put_marca_rejilla(char *informe,char marca)
{
	  unsigned char d,i,v,e;

      LV_FINDINFO info;

	  info.flags=LVFI_STRING;
	  info.psz=informe;
	  
	  int numero=lista->FindItem(&info);

	  d=LOBYTE(LOWORD(lista->GetItemData(numero)));
      i=HIBYTE(LOWORD(lista->GetItemData(numero)));
	  v=LOBYTE(HIWORD(lista->GetItemData(numero)));
	  e=HIBYTE(HIWORD(lista->GetItemData(numero)));

	  lista->SetItemData(numero,MAKELPARAM(MAKEWORD(d,(unsigned char) marca),MAKEWORD(v,e))); 
}

void listado1::put_marca_ver(char *informe,char marca)
{
	  unsigned char d,i,v,e;

	  LV_FINDINFO info;

	  info.flags=LVFI_STRING;
	  info.psz=informe;
	  
	  int numero=lista->FindItem(&info);

	  d=LOBYTE(LOWORD(lista->GetItemData(numero)));
      i=HIBYTE(LOWORD(lista->GetItemData(numero)));
	  v=LOBYTE(HIWORD(lista->GetItemData(numero)));
	  e=HIBYTE(HIWORD(lista->GetItemData(numero)));

	  lista->SetItemData(numero,MAKELPARAM(MAKEWORD(d,i),MAKEWORD((unsigned char) marca,e)));
}

void listado1::put_marca_exec(char *informe,char marca)
{
	  unsigned char d,i,v,e;

	  LV_FINDINFO info;

	  info.flags=LVFI_STRING;
	  info.psz=informe;
	  
	  int numero=lista->FindItem(&info);

	  d=LOBYTE(LOWORD(lista->GetItemData(numero)));
      i=HIBYTE(LOWORD(lista->GetItemData(numero)));
	  v=LOBYTE(HIWORD(lista->GetItemData(numero)));
	  e=HIBYTE(HIWORD(lista->GetItemData(numero)));

	  lista->SetItemData(numero,MAKELPARAM(MAKEWORD(d,i),MAKEWORD(v,(unsigned char) marca)));
}

BOOL listado1::PreTranslateMessage(MSG *pMsg)
{
	  listado *li=(listado *) parent;

	  if (pMsg->message == WM_KEYDOWN) {
		 if (pMsg->wParam == VK_DELETE) { 
			if (li->acceso!='R') {
               int numero=obtener_seleccionado();
               if (numero>=0) li->borrar(numero);
			}
            return TRUE;
		 } 
      }

      return CButton::PreTranslateMessage(pMsg);	  
}

BEGIN_MESSAGE_MAP(listado,CDialog)
//{{AFX_MSG_MAP(listado)
ON_WM_SIZE()
ON_WM_CLOSE()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void listado::create(CWnd *parent, char *opcion, char autorizacion, char *no, char *di, char *us, char *pa, sql_context contexto, int b)
{
	  register int t,r;
      CRect rect;
	  int j,i,l,n,px,py,lx,ly,f,g;
	  char texto[512],linea[251],fichero[25];
	  FILE *fi;
	  HICON icon[5];

	  size_bitmap=b;

	  contex_gen=contexto;
	  strcpy(nom,no);
	  strcpy(dir,di);
	  strcpy(usu,us);
	  strcpy(pass,pa);

	  if (!autorizacion) {
         if (er) delete er;
		 er = new error_aplicacion;
         if (lenguaje=='E')
		    er->create("Usuario no autorizado");
         else
            er->create("User not authorised");
	  } else {
         acceso=autorizacion;
	     strcpy(nombre,opcion);

	     icon[0]=AfxGetApp()->LoadIcon("IDC_NUEVO");
	     icon[1]=AfxGetApp()->LoadIcon("IDC_HOJAS");
	     icon[2]=AfxGetApp()->LoadIcon("IDC_VER");
	     icon[3]=AfxGetApp()->LoadIcon("IDC_VER_GRID");
		 icon[4]=AfxGetApp()->LoadIcon("IDC_CERRAR");

		 vi = new visu[5];
	     ex = new exec[5];
		 gr = new visu_excel[5];
		 
		 for (t=0;t<5;t++) indicador_ex[t]=0;
		 for (t=0;t<5;t++) indicador_vi[t]=0;
		 for (t=0;t<5;t++) indicador_gr[t]=0;

		 if (acceso=='I') {
            ed = new editlis[5];
			for (t=0;t<5;t++) indicador_ed[t]=0;
		 }
		 		 
	     strcpy(fichero,nombre);
	     strcat(fichero,".lst");

	     if ((fi=fopen(fichero,"r"))!=NULL) {
	        do {
               for (t=0;t<7;t++) l=leelin(fi,linea);
		       if (l==EOF) break;
		       l=leelin(fi,linea);
		       if (l==EOF) break;
               if (lenguaje!='E') {
                  l=leelin(fi,linea);
		          if (l==EOF) break;
               }
		       rtrim(linea);
			   break;
			} while(1);
		    fclose(fi);
		 }

	     f=(76*4)+2;
	     g=(150*baseY)/8;

         lx=((f*baseX)/4)+2;
	     ly=25+g+baseM+((10*baseY)/8);
         if (ly>(baseTY-10)) ly=baseTY-10;
         if (lx>(baseTX-10)) lx=baseTX-10;
	     rect.SetRect(0,0,lx,ly);

         AdjustWindowRectEx(rect,WS_POPUP | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME,FALSE,0);

	     px=strlen(nombre)*2;
	     py=5*baseM;
	     px=(px*baseX)/4;
         if ((px+lx)>baseTX) px=baseTX-lx;
         if ((py+ly)>baseTY) py=baseTY-ly;
	     
		 strcpy(texto,nom);
		 if (*nom) strcat(texto," - ");
	     strcat(texto,linea);
	     strcat(texto," ");
         if (lenguaje=='E')
	        strcat(texto,"(lista de informes)");
         else
            strcat(texto,"(report list)");
	  
	     CreateEx(0,xd_wnd_class,texto,WS_POPUP | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME,px,py,rect.Width(),rect.Height(),parent->m_hWnd,NULL);

		 CWaitCursor cursor;

         lx=((f*baseX)/4)+2;
	     rect.SetRect(1,25,lx+1,g+25);

	     li1.create(this,&rect);

	     py=4;
	     ly=24;
		 px=((f*baseX)/4)+2-(size_bitmap+5);
	     lx=px+size_bitmap;
         titulo->Create("titulo",WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_OWNERDRAW,CRect(px,py,lx,ly),this,NULL);
         titulo->LoadBitmaps("IDB_APLICACION",NULL,NULL,NULL);

         n=6;
		 r=0;

	     for (t=0;t<5;t++) {
            if (acceso!='I' && t<2) continue;
			if (r) n+=23;
			r++;
			if (t==1 || t==4) n+=10;
	        tool[t]->Create(NULL,WS_CHILD | WS_VISIBLE | WS_TABSTOP,CRect(n,4,n+23,26),this,NULL);
	        tool[t]->ModifyStyle(0,BS_ICON | BS_CENTER);
	        tool[t]->SetIcon(icon[t]);
			if (acceso=='R' && t==4) tool[t]->ModifyStyle(0,WS_DISABLED);
		 }

		 j=5;
	  
         for (t=0;t<2;t++) {
            if (lenguaje=='E') {
               if (!t) strcpy(texto,"Salir");
               if (t==1) strcpy(texto,"Ayuda");   
            } else {
               if (!t) strcpy(texto,"Exit");
               if (t==1) strcpy(texto,"Help");  
            }
            i=25+g+((5*baseY)/8);     
		    l=i+baseM;
		    n=j+(4*5)+4;
		    px=(j*baseX)/4;
	        lx=(n*baseX)/4;
            boton[t]->Create(texto,WS_CHILD | WS_VISIBLE | WS_TABSTOP,CRect(px,i,lx,l),this,NULL);
            boton[t]->SetFont(fonm,TRUE);
		    j+=5+(4*5)+4;
		 }

	     tip->Create(this,TTS_ALWAYSTIP);
	  	 
	     for (t=0;t<6;t++) textip[t]=(char *) malloc(51);

         if (lenguaje=='E') {
		    strcpy(textip[0],"Nuevo informe");
		    strcpy(textip[1],"Editar informe");
		    strcpy(textip[2],"Visualizar informe");
			strcpy(textip[3],"Visualizar formato de exportacin");
		    strcpy(textip[4],"Cerrar/Reabrir revisin");
         } else {
            strcpy(textip[0],"New report");
		    strcpy(textip[1],"Edit report");
		    strcpy(textip[2],"View report");
            strcpy(textip[3],"View export format");
		    strcpy(textip[4],"Close/Open revision");
         }
		 strcpy(textip[5],identificacion_aplicacion);
		 
		 for (t=0;t<5;t++) {
            if (acceso!='I' && t<2) continue;
            tip->AddTool(tool[t],textip[t]);
		 }
		     
	     tip->AddTool(titulo,textip[t]);

	     tip->Activate(TRUE);

         this->ShowWindow(SW_SHOW);
	     indicador=1;
	  }
}

void listado::set_tool(int numero)
{
      tool[numero]->EnableWindow(TRUE);
}

void listado::unset_tool(int numero)
{
      tool[numero]->EnableWindow(FALSE);
}

void listado::OnSize(UINT nType,int cx,int cy)
{
	  int px,py,lx,ly;

      px=(((40*4)*baseX)/4)+7+GetSystemMetrics(SM_CXVSCROLL);
            
      if (cx<px) {
         cx=px;
         CRect rect;
         rect.SetRect(0,0,cx,cy);
         AdjustWindowRectEx(rect,WS_POPUP | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME | WS_MAXIMIZEBOX,FALSE,0);
         cx=rect.Width();
         cy=rect.Height();
         GetWindowRect(&rect);
         MoveWindow(rect.TopLeft().x,rect.TopLeft().y,cx,cy,TRUE);
         return;
      } 

      py=(baseY*10)+baseM+(((baseV-baseY)/2)*(7+2))+baseM+((10*baseY)/8);

      if (cy<py) {
         cy=py;
         CRect rect;
         rect.SetRect(0,0,cx,cy);
         AdjustWindowRectEx(rect,WS_POPUP | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME | WS_MAXIMIZEBOX,FALSE,0);
         cx=rect.Width();
         cy=rect.Height();
         GetWindowRect(&rect);
         MoveWindow(rect.TopLeft().x,rect.TopLeft().y,cx,cy,TRUE);
         return;
      } 
	 
	  CDialog::OnSize(nType,cx,cy);

	  if (titulo->m_hWnd) {
         py=4;
	     px=cx-(size_bitmap+5);
         titulo->InvalidateRgn(NULL);
	     titulo->MoveWindow(px,py,size_bitmap,20,TRUE);
	  }
	     
	  if (boton[0]->m_hWnd) {
		 px=(5*baseX)/4;
		 py=((5*baseY)/8)+baseM;
		 lx=(((4*5)+4)*baseX)/4;
         boton[0]->InvalidateRgn(NULL);
	     boton[0]->MoveWindow(px,cy-py,lx,baseM,TRUE);
      }

	  if (boton[1]->m_hWnd) {
		 px=((10+(4*5)+4)*baseX)/4;
		 py=((5*baseY)/8)+baseM;
		 lx=(((4*5)+4)*baseX)/4;
         boton[1]->InvalidateRgn(NULL);
	     boton[1]->MoveWindow(px,cy-py,lx,baseM,TRUE);
      }

      if (li1.m_hWnd) {
		 py=25;
		 ly=25+((10*baseY)/8)+baseM;
         li1.InvalidateRgn(NULL);
	     li1.MoveWindow(1,py,cx-4,cy-ly,TRUE);
	  }
}

BOOL listado::PreTranslateMessage(MSG *pMsg)
{
	  switch(pMsg->message) {
	     case WM_LBUTTONDOWN:
         case WM_RBUTTONDOWN:
         case WM_MBUTTONDOWN:
         case WM_LBUTTONUP:
         case WM_RBUTTONUP:
         case WM_MBUTTONUP:
         case WM_MOUSEMOVE:
            tip->Activate(TRUE);
            tip->RelayEvent(pMsg);
      } 

	  if (pMsg->message == WM_LBUTTONDBLCLK) {
         UINT nFlags;
		 this->ScreenToClient(&(pMsg->pt));
		 pMsg->pt.x-=2;
		 pMsg->pt.y-=(25+(baseY/2));
		 int numero = li1.lista->HitTest(pMsg->pt,&nFlags);
         if (numero != -1 && nFlags & LVHT_ONITEM) {
            ejecutar(numero);
            return TRUE;
		 }
      }

      if (pMsg->message == WM_KEYDOWN) {
		 if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE ||
             pMsg->wParam == VK_F1) { 
			this->SendMessage(WM_KEYDOWN,pMsg->wParam);
			return TRUE;
         } 
      }

      return CDialog::PreTranslateMessage(pMsg);	  
}

void listado::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
      CDialog::OnKeyDown(nChar,nRepCnt,nFlags);
      
      if (nChar == VK_F1) {
		 desplegar_ayuda();
/*		 char text[128];
		 strcpy(text,AfxGetApp()->m_pszHelpFilePath);
		 strcat(text,"::/html/listados.htm");
		 HtmlHelp(m_hWnd,text,HH_DISPLAY_TOPIC,0);*/
	  }
}

void listado::OnClose()
{
      salir();
}

int listado::salir()
{
	  register int t;

	  for (t=0;t<5;t++) {
		 if (indicador_ex[t]) {
			if (ex[t].salir()) {
               if (er) delete er;
		       er = new error_aplicacion;
               if (lenguaje=='E')
		          er->create("Informe en ejecucion.");
               else
                  er->create("Report executing.");
			   return(1);
			}
		 }
	  }

      for (t=0;t<5;t++) {
		 if (indicador_vi[t]) vi[t].salir();
		 if (indicador_gr[t]) gr[t].salir();
	  }

	  this->ShowWindow(SW_HIDE);
	  this->DestroyWindow();
	  delete li1.mask;
	  delete li1.peq;
	  delete li1.imagen;
	  delete li1.lista;
	  for (t=0;t<6;t++) free(textip[t]);
	  delete [] ex;
	  delete [] vi;
	  delete [] gr;
	  if (acceso=='I') delete [] ed;
      indicador=0;
	  return(0);
}

void listado::editar(int numero)
{
      char informe[16],oficial[2],descripcion[41],fecha[11];
	  int revision;
	  register int t;
	  
	  char d=li1.get_marca_edit(numero);

	  if (!d) {
         revision=li1.obtener_registro(numero,informe,oficial,descripcion,fecha);
         for (t=0;t<5;t++) {
            if (!indicador_ed[t]) break;
		 }
		 if (t==5) {
            if (er) delete er;
			er = new error_aplicacion;
            if (lenguaje=='E')
			   er->create("Excedido el numero mximo (5) de\ninformes editados.");
            else
               er->create("Maximum number (5) of edited reports reached.");
		 } else
            ed[t].create(this,informe,descripcion,t);
	  }
}

void listado::ver(int numero)
{
	  char fichero[256],informe[16],oficial[2],descripcion[41],fecha[11],revi[3];
	  int revision;
	  register int t;
	  	  
      char v=li1.get_marca_ver(numero);
	  char e=li1.get_marca_exec(numero);

	  if (!v && !e) {
	     revision=li1.obtener_registro(numero,informe,oficial,descripcion,fecha);	  
         for (t=0;t<5;t++) {
            if (!indicador_vi[t]) break;
		 }
		 if (t==5) {
            if (er) delete er;
			er = new error_aplicacion;
            if (lenguaje=='E')
			   er->create("Excedido el numero mximo (5) de\ninformes visualizados.");
            else
               er->create("Maximum number (5) of viewed reports reached.");
		 } else {
			strcpy(fichero,dir);
            strcat(fichero,"\\");
	        strcat(fichero,informe);
	        strcat(fichero,"_");
	        sprintf(revi,"%02d",revision);
	        strcat(fichero,revi);
	        strcat(fichero,".lis");

			if (revision) vi[t].create(this,informe,t);
		 }
	  }
}

void listado::ver_rejilla(int numero)
{
	  char fichero[256],informe[16],oficial[2],descripcion[41],fecha[11],revi[3];
	  int revision;
	  register int t;
	  	  
      char g=li1.get_marca_rejilla(numero);
	  char e=li1.get_marca_exec(numero);

	  if (!g && !e) {
	     revision=li1.obtener_registro(numero,informe,oficial,descripcion,fecha);	  
         for (t=0;t<5;t++) {
            if (!indicador_gr[t]) break;
		 }
		 if (t==5) {
            if (er) delete er;
			er = new error_aplicacion;
            if (lenguaje=='E')
			   er->create("Excedido el numero mximo (5) de\nformatos visualizados.");
            else
               er->create("Maximum number (5) of viewed formats reached.");
		 } else {
			strcpy(fichero,dir);
            strcat(fichero,"\\");
	        strcat(fichero,informe);
	        strcat(fichero,"_");
	        sprintf(revi,"%02d",revision);
	        strcat(fichero,revi);
	        strcat(fichero,".xis");

			if (revision) gr[t].create(this,informe,t);
		 }
	  }
}

void listado::nuevo()
{
	  register int t;
	  char informe[16],descripcion[41];
	  
	  for (t=0;t<5;t++) {
            if (!indicador_ed[t]) break;
	  }
	  if (t==5) {
         if (er) delete er;
	     er = new error_aplicacion;
         if (lenguaje=='E')
		    er->create("Excedido el numero mximo (5) de\ninformes editados.");
         else
            er->create("Maximum number (5) of edited reports reached.");
	  } else {
         informe[0]='\0';
         descripcion[0]='\0';
         ed[t].create(this,informe,descripcion,t);
	  }
}

void listado::cerrar(int numero)
{
	  char fichero[256],file[256],informe[16],oficial[2],descripcion[41],fecha[11],revi[3];
	  int revision,n_vari,resul,l,tipo[1];
	  char texto[201],linea[101],senten[2048],valor[1][61],tex_er[71];
	  FILE *fi;
	  
	  revision=li1.obtener_registro(numero,informe,oficial,descripcion,fecha);	  

	  if (revision) {
	     char g=li1.get_marca_rejilla(numero);
	     char d=li1.get_marca_edit(numero);
	     char e=li1.get_marca_exec(numero);
	     char v=li1.get_marca_ver(numero);

         if (g || d || e || v) {
            if (er) delete er;
		    er = new error_aplicacion;
            if (lenguaje=='E')
		       strcpy(texto,"Informe ");
            else
               strcpy(texto,"Report ");
		    strcat(texto,informe);
            if (lenguaje=='E')
		       strcat(texto," en uso.\n\nNo se puede cambiar el estado de la revisin.");
            else
               strcat(texto," in use.\n\nCan't change revision status.");
		    er->create(texto);                           
		 } else {

            char tab_ide[16];

            strcpy(fichero,nombre);
            strcat(fichero,".lst");

            if ((fi=fopen(fichero,"r"))!=NULL) {
               do {
                  l=leelin(fi,linea);
	              rtrim(linea);
	              strcpy(tab_ide,linea);
                  break;
			   } while(1);
		       fclose(fi);
			}

            strcpy(fichero,dir);
            strcat(fichero,"\\");
            strcat(fichero,informe);
	        strcat(fichero,"_");
	        sprintf(revi,"%02d",revision);
	        strcat(fichero,revi);
			strcpy(file,fichero);
	        strcat(fichero,".lis");
			strcat(file,".xis");

			if (strcmp(oficial,"O")) {
               resul=ral_or(contex_gen,fichero,tab_ide,informe,revision,'U',tex_er);

               strcpy(senten,"update ");
		       strcat(senten,tab_ide);
		       strcat(senten," set oficial=");
		       strcat(senten,"'O'");
		       strcat(senten," where listado='");
		       strcat(senten,informe);
		       strcat(senten,"' and revision=");
		       strcat(senten,revi);
		       resul=sq1_or(contex_gen,senten,valor,tipo,n_vari,tex_er);

		       if (resul) {
                  if (lenguaje=='E')
	                 strcpy(texto,"No se puede cambiar el estado de la revisin.\n\nError de ORACLE:\n\n");
                  else
                     strcpy(texto,"Can't change revision status.\n\nORACLE error:\n\n");
                  strcat(texto,tex_er);
                  if (er) delete er;
                  er = new error_aplicacion;
                  er->create(texto);
                  return;
               } else {
                  co_or(contex_gen);
			      li1.lista->SetItemText(numero,2,"O");
			      _unlink(fichero);
			      _unlink(file);
                  li1.asignar_imagen(numero);
			   }
            } else {
               resul=ral_or(contex_gen,fichero,tab_ide,informe,revision,'S',tex_er);

			   strcpy(senten,"update ");
		       strcat(senten,tab_ide);
		       strcat(senten," set oficial=");
		       strcat(senten,"NULL");
		       strcat(senten," where listado='");
		       strcat(senten,informe);
		       strcat(senten,"' and revision=");
		       strcat(senten,revi);
		       resul=sq1_or(contex_gen,senten,valor,tipo,n_vari,tex_er);

		       if (resul) {
                  if (lenguaje=='E')
	                 strcpy(texto,"No se puede cambiar el estado de la revisin.\n\nError de ORACLE:\n\n");
                  else
                     strcpy(texto,"Can't change revision status.\n\nORACLE error:\n\n");
                  strcat(texto,tex_er);
                  if (er) delete er;
                  er = new error_aplicacion;
                  er->create(texto);
                  return;
               } else {
                  co_or(contex_gen);
			      li1.lista->SetItemText(numero,2,"\0");
                  li1.asignar_imagen(numero);
			   }
            }
		 }
	  }
}

void listado::borrar(int numero)
{
	  char fichero[256],file[256],informe[16],oficial[2],descripcion[41],fecha[11],revi[3];
	  int revision,j,n_vari,tipo[1],l,resul;
	  char texto[201],linea[101],senten[2048],valor[1][61],tex_er[71];
	  FILE *fi;

	  revision=li1.obtener_registro(numero,informe,oficial,descripcion,fecha);	  

	  char g=li1.get_marca_rejilla(numero);
	  char d=li1.get_marca_edit(numero);
	  char e=li1.get_marca_exec(numero);
	  char v=li1.get_marca_ver(numero);

	  if (g || d || e || v) {
         if (er) delete er;
		 er = new error_aplicacion;
         if (lenguaje=='E')
		    strcpy(texto,"Informe ");
         else
            strcpy(texto,"Report ");
		 strcat(texto,informe);
         if (lenguaje=='E')
		    strcat(texto," en uso.\n\nNo se puede borrar.");
         else
            strcat(texto," in use.\n\nCan't delete it.");
		 er->create(texto);                           
	  } else {
         if (revision<2) {
			if (acceso!='I') return;
            if (lenguaje=='E')
               strcpy(texto,"Desea borrar el informe ");
            else
               strcpy(texto,"Delete report ");
	        strcat(texto,informe);
            strcat(texto,"?");
         } else {
            if (lenguaje=='E')
               strcpy(texto,"Desea borrar la revisin ");
            else
               strcpy(texto,"Delete the revision ");
            sprintf(revi,"%2d",revision);
            strcat(texto,revi);
            if (lenguaje=='E')
               strcat(texto," del informe ");
            else
               strcat(texto," of the report ");
            strcat(texto,informe);
            strcat(texto,"?");
         }

         if (lenguaje=='E') 
	        j=MessageBoxEx(this->m_hWnd,texto,"borrar",MB_YESNO | MB_TASKMODAL | MB_DEFBUTTON2 |
		                   MB_ICONQUESTION,MAKELANGID(LANG_SPANISH,SUBLANG_SPANISH));
         else
            j=MessageBoxEx(this->m_hWnd,texto,"delete",MB_YESNO | MB_TASKMODAL | MB_DEFBUTTON2 |
                           MB_ICONQUESTION,MAKELANGID(LANG_ENGLISH,SUBLANG_ENGLISH_US));

	     if (j==IDYES) {
            
            CWaitCursor cursor;

            char tab_cam[16],tab_ide[16],tab_car[16],tab_con[16],tab_tex[16],tab_img[16],tab_col[16];

	        strcpy(fichero,nombre);
            strcat(fichero,".lst");

            if ((fi=fopen(fichero,"r"))!=NULL) {
               do {
                  l=leelin(fi,linea);
				  rtrim(linea);
	              strcpy(tab_ide,linea);
                  l=leelin(fi,linea);
				  rtrim(linea);
	              strcpy(tab_car,linea);
                  l=leelin(fi,linea);
				  rtrim(linea);
	              strcpy(tab_tex,linea);
                  l=leelin(fi,linea);
				  rtrim(linea);
	              strcpy(tab_cam,linea);
                  l=leelin(fi,linea);
				  rtrim(linea);
	              strcpy(tab_img,linea);
                  l=leelin(fi,linea);
				  rtrim(linea);
	              strcpy(tab_con,linea);
				  l=leelin(fi,linea);
				  rtrim(linea);
	              strcpy(tab_col,linea);
  	              break;
			   } while(1);
		       fclose(fi);
			}

            if (revision<2) {
               strcpy(senten,"delete ");
	           strcat(senten,tab_car);
	           strcat(senten," where listado='");
	           strcat(senten,informe);
	           strcat(senten,"'");
	           resul=sq1_or(contex_gen,senten,valor,tipo,n_vari,tex_er);

			   strcpy(senten,"delete ");
	           strcat(senten,tab_tex);
	           strcat(senten," where listado='");
	           strcat(senten,informe);
	           strcat(senten,"'");
	           resul=sq1_or(contex_gen,senten,valor,tipo,n_vari,tex_er);

			   strcpy(senten,"delete ");
	           strcat(senten,tab_cam);
	           strcat(senten," where listado='");
	           strcat(senten,informe);
	           strcat(senten,"'");
	           resul=sq1_or(contex_gen,senten,valor,tipo,n_vari,tex_er);

			   strcpy(senten,"delete ");
	           strcat(senten,tab_img);
	           strcat(senten," where listado='");
	           strcat(senten,informe);
	           strcat(senten,"'");
	           resul=sq1_or(contex_gen,senten,valor,tipo,n_vari,tex_er);

			   strcpy(senten,"delete ");
	           strcat(senten,tab_con);
	           strcat(senten," where listado='");
	           strcat(senten,informe);
	           strcat(senten,"'");
	           resul=sq1_or(contex_gen,senten,valor,tipo,n_vari,tex_er);

			   strcpy(senten,"delete ");
	           strcat(senten,tab_col);
	           strcat(senten," where listado='");
	           strcat(senten,informe);
	           strcat(senten,"'");
	           resul=sq1_or(contex_gen,senten,valor,tipo,n_vari,tex_er);

			   strcpy(senten,"delete ");
	           strcat(senten,tab_ide);
	           strcat(senten," where listado='");
	           strcat(senten,informe);
	           strcat(senten,"'");
	           resul=sq1_or(contex_gen,senten,valor,tipo,n_vari,tex_er);

               if (resul) {
                  if (lenguaje=='E')
	                 strcpy(texto,"No se puede borrar el informe.\n\nError de ORACLE:\n\n");
                  else
                     strcpy(texto,"Can't delete the report.\n\nORACLE error:\n\n");
                  strcat(texto,tex_er);
                  if (er) delete er;
                  er = new error_aplicacion;
                  er->create(texto);
               } else {
                  co_or(contex_gen);
                  li1.lista->DeleteItem(numero);

			      strcpy(fichero,dir);
                  strcat(fichero,"\\");
	              strcat(fichero,informe);
	              strcat(fichero,"_");
	              sprintf(revi,"%02d",revision);
	              strcat(fichero,revi);
				  strcpy(file,fichero);
	              strcat(fichero,".lis");
				  strcat(file,".xis");
			      _unlink(fichero);
				  _unlink(file);
               }
            } else {
               strcpy(senten,"delete ");
	           strcat(senten,tab_ide);
	           strcat(senten," where listado='");
	           strcat(senten,informe);
	           strcat(senten,"' and revision=");
               strcat(senten,revi);
	           resul=sq1_or(contex_gen,senten,valor,tipo,n_vari,tex_er);

               if (resul) {
                  if (lenguaje=='E')
	                 strcpy(texto,"No se puede borrar la revision del informe.\n\nError de ORACLE:\n\n");
                  else
                     strcpy(texto,"Can't delete the report.\n\nORACLE error:\n\n");
                  strcat(texto,tex_er);
                  if (er) delete er;
                  er = new error_aplicacion;
                  er->create(texto);
               } else {
                  co_or(contex_gen);
                  li1.actualizar_registro(informe);

				  strcpy(fichero,dir);
                  strcat(fichero,"\\");
	              strcat(fichero,informe);
	              strcat(fichero,"_");
	              sprintf(revi,"%02d",revision);
	              strcat(fichero,revi);
				  strcpy(file,fichero);
	              strcat(fichero,".lis");
				  strcat(file,".xis");
			      _unlink(fichero);
				  _unlink(file);
               }
            }
         }
	  }
}

void listado::ejecutar(int numero)
{
	  char informe[16],oficial[2],descripcion[41],fecha[11];
	  int revision;
	  register int t;
	  
	  char e=li1.get_marca_exec(numero);
	  char v=li1.get_marca_ver(numero);
	  char g=li1.get_marca_rejilla(numero);

	  if (!e && !v && !g) {
         revision=li1.obtener_registro(numero,informe,oficial,descripcion,fecha);	  
		 for (t=0;t<5;t++) {
            if (!indicador_ex[t]) break;
		 }
		 if (t==5) {
            if (er) delete er;
		    er = new error_aplicacion;
            if (lenguaje=='E')
		       er->create("Excedido el numero mximo (5) de\ninformes en ejecucin");
            else
               er->create("Maximum number (5) of reports in executing process reached");
		 } else
            ex[t].create(this,informe,revision,oficial,t);
	  }
}

BOOL listado::OnCommand(WPARAM wParam, LPARAM lParam)
{
	  UINT notificationCode = (UINT) HIWORD(wParam);
	  
	  if (notificationCode == BN_CLICKED) {
         int i;
         i=li1.obtener_seleccionado();
	     CWnd *button = CWnd::GetFocus();
         if (button == tool[0]) nuevo();
         if (button == tool[1] && i>=0) editar(i);
         if (button == tool[2] && i>=0) ver(i);
		 if (button == tool[3] && i>=0) ver_rejilla(i);
         if (button == tool[4] && i>=0) cerrar(i);
         if (button == boton[0]) salir();
         if (button == boton[1]) {
			desplegar_ayuda();
	/*	    char text[128];
		    strcpy(text,AfxGetApp()->m_pszHelpFilePath);
		    strcat(text,"::/html/listados.htm");
		    HtmlHelp(m_hWnd,text,HH_DISPLAY_TOPIC,0); */
		 }
		 return FALSE;
	  }
    
	  return CDialog::OnCommand(wParam, lParam);
}

int listado::obtener_indicador()
{
	  return indicador;
}

listado::listado()
{
	  register int t;

      for (t=0;t<2;t++) boton[t] = new CButton;
	  tip = new CToolTipCtrl;
	  titulo = new CBitmapButton;
	  for (t=0;t<5;t++) tool[t] = new CButton;
	  
	  indicador=0;
}

listado::~listado()
{
	  register int t;

      for (t=0;t<5;t++) delete tool[t];
      for (t=0;t<2;t++) delete boton[t];
	  delete tip;
	  delete titulo;
}

